Index: src/code.l
===================================================================
RCS file: /cvsroot/doxygen/src/code.l,v
retrieving revision 1.137
diff -u -5 -r1.137 code.l
--- src/code.l	4 Oct 2006 20:28:40 -0000	1.137
+++ src/code.l	24 Oct 2006 20:36:45 -0000
@@ -53,13 +53,10 @@
 
 static ClassSDict    *g_codeClassSDict = 0;
 static QCString      g_curClassName;
 static QStrList      g_curClassBases;
 
-// TODO: is this still needed? if so, make it work
-static bool          g_inClass;
-
 static QCString      g_parmType;
 static QCString      g_parmName;
 
 static const char *  g_inputString;     //!< the code fragment as text
 static int	     g_inputPosition;   //!< read offset during parsing 
@@ -371,14 +368,16 @@
 };
 
 static CallContext g_theCallContext;
 
 //-------------------------------------------------------------------
+static QStack<int>   g_classScopeLengthStack;
 
 /*! add class/namespace name s to the scope */
 static void pushScope(const char *s)
 {
+  g_classScopeLengthStack.push(new int(g_classScope.length()));
   if (g_classScope.isEmpty())
   {
     g_classScope = s;
   }
   else
@@ -390,21 +389,15 @@
 }
 
 /*! remove the top class/namespace name from the scope */
 static void popScope()
 {
-  if (!g_classScope.isEmpty())
+  if (!g_classScopeLengthStack.isEmpty())
   {
-    int i=g_classScope.findRev("::");
-    if (i==-1) // last name, strip all
-    {
-      g_classScope.resize(0);
-    } 
-    else // strip name
-    {
-      g_classScope = g_classScope.left(i);
-    }
+    int* plength = g_classScopeLengthStack.pop();
+    g_classScope.truncate(*plength);
+    delete plength;
   }
   else
   {
     //err("Error: Too many end of scopes found!\n");
   }
@@ -1721,11 +1714,10 @@
 <ObjCParams,ObjCMethod>";"|"{"		{
   					  g_code->codify(yytext);
 					  if (*yytext=='{')
 					  {
 					    g_curlyCount++;
-					    g_inClass=TRUE;
   					    if (g_searchingForBody)
 					    {
 					      g_searchingForBody=FALSE;
 					      g_insideBody=TRUE;
 					    }
@@ -1867,12 +1859,10 @@
 					    popScope();
 					  }
 
   					  g_code->codify(yytext);
 
-  					  g_inClass=FALSE; 
-
 					  //fprintf(stderr,"g_bodyCurlyCount=%d\n",g_bodyCurlyCount);
 					  if (--g_bodyCurlyCount<=0)
 					  {
 					    g_insideBody=FALSE;
 					    g_currentMemberDef=0;
@@ -1908,12 +1898,10 @@
 
 					  startFontClass("keyword");
   					  g_code->codify(yytext);
 					  endFontClass();
 
-  					  g_inClass=FALSE; 
-
 					  g_currentMemberDef=0;
 					  if (g_currentDefinition) 
 					    g_currentDefinition=g_currentDefinition->getOuterScope();
 					  BEGIN(Body);
 					}
@@ -1966,11 +1954,10 @@
 <PackageName>[ \t]*";"				|
 <Bases,ClassName,ClassVar>[ \t]*"{"[ \t]*	{
                                           g_theVarContext.pushScope();
   					  g_code->codify(yytext);
 					  g_curlyCount++;
-					  g_inClass=TRUE;
 					  if (YY_START==ClassVar && g_curClassName.isEmpty())
 					  {
 					    g_curClassName = g_name.copy();
 					  }
   					  if (g_searchingForBody)
@@ -2593,11 +2580,11 @@
   */
 <CallEnd>[;:]				{
   					  codifyLines(yytext);
   					  g_bracketCount=0;
 					  if (*yytext==';') g_searchingForBody=FALSE; 
-					  if (!g_inClass && !g_type.isEmpty())
+					  if (!g_type.isEmpty())
 					  {
 					    //fprintf(stderr,"add variable g_type=%s g_name=%s)\n",g_type.data(),g_name.data());
 					    g_theVarContext.addVariable(g_type,g_name);
 					  }
 					  g_parmType.resize(0);g_parmName.resize(0);
